package sample;

import java.util.HashMap;

import org.json.JSONObject;

import com.youku.uploader.IUploadResponseHandler;
import com.youku.uploader.R;
import com.youku.uploader.YoukuUploader;

import android.os.Bundle;
import android.os.Environment;
import android.app.Activity;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ProgressBar;
import android.widget.TextView;

public class MainActivity extends Activity implements OnClickListener {

	private ProgressBar progressBar;

	private TextView percent;

	private YoukuUploader uploader;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		progressBar = (ProgressBar) findViewById(R.id.progressbar);
		percent = (TextView) findViewById(R.id.percent);
//请替换成自己的clientid与clientsecret
		uploader = YoukuUploader.getInstance("792b1d08a5348d0d", "9a98ce3841ae9f686fbea940a93b8167", getApplicationContext());
		bindEvents();
	}

	private void bindEvents() {
		findViewById(R.id.upload).setOnClickListener(this);
		findViewById(R.id.cancel).setOnClickListener(this);
	}

	@Override
	public void onClick(View v) {

		switch (v.getId()) {

		case R.id.upload:
			HashMap<String, String> params = new HashMap<String, String>();
//access_token可以在http://cloud.youku.com/tools的手动获取选项卡获取
			params.put("access_token", "ef399e3997a657e8c52a767cb7882b21");
			HashMap<String, String> uploadInfo = new HashMap<String, String>();
			uploadInfo.put("title", "优酷上传测试");
			uploadInfo.put("tags", "优酷,EVA");
			uploadInfo.put("file_name", Environment
					.getExternalStorageDirectory().getPath()
					+ "/video.mp4");

			uploader.upload(params, uploadInfo, new IUploadResponseHandler() {

				@Override
				public void onStart() {
					Log.v("Main upload", "onStart");
					progressBar.setProgress(0);
					percent.setText("等待中");
				}

				@Override
				public void onSuccess(JSONObject response) {
					Log.v("Main upload onSuccess", response.toString());
				}

				@Override
				public void onProgressUpdate(int counter) {
					Log.v("Main upload onProgress", counter + "");
					progressBar.setProgress(counter);
					percent.setText(counter + "%");
				}

				@Override
				public void onFailure(JSONObject errorResponse) {
					Log.v("Main upload onFailure JsonObject", errorResponse.toString());
				}

				@Override
				public void onFinished() {
					Log.v("Main upload", "onFinished");
					percent.setText("完成");
				}
			});
			break;

		case R.id.cancel:
			if (uploader.cancel()) {
				progressBar.setProgress(0);
				percent.setText("");
			}
			break;
		}
	}
}
